.if !defined(_POSTMKINCLUDED) && !defined(Crossbuild_Pre_Include)

Crossbuild_Pre_Include=		bsd.crossbuild.mk
Crossbuild_Include_MAINTAINER=	trhodes@FreeBSD.org

# This file contains some variable definitions that are supposed to
# make your life easier when dealing with crossbuilding ports.
#

#
# XXXTR: Define source tree for toolchain stuff.
#
SRC_TREE?=	/usr/src

#
# Set TARGET_ARCH to TARGET for simplification
#
.if defined(TARGET) && !defined(TARGET_ARCH)
TARGET_ARCH?=	${TARGET}
#.endif

# XXXTR: Check for valid archs
.if defined(TARGET_ARCH) && !defined(TARGET)
.error TARGET_ARCH requires TARGET
.endif

.if defined(TARGET) && defined(TARGET_ARCH)
.if !exists(/usr/obj/${TARGET}.${TARGET_ARCH}/${SRC_TREE}/tmp/usr/bin)
# Sigh, need to build toolchain
post-patch: dotcbuild
.endif
.endif

# It would be easier, I think, to pass in a new $PATH directive.
CC=/usr/obj/${TARGET_ARCH}.${TARGET_ARCH}/usr/src/tmp/usr/bin/gcc
CPP=/usr/obj/${TARGET_ARCH}.${TARGET_ARCH}/usr/src/tmp/usr/bin/cpp
CXX=/usr/obj/${TARGET_ARCH}.${TARGET_ARCH}/usr/src/tmp/usr/bin/g++
AS=/usr/obj/${TARGET_ARCH}.${TARGET_ARCH}/usr/src/tmp/usr/bin/as
NM=/usr/obj/${TARGET_ARCH}.${TARGET_ARCH}/usr/src/tmp/usr/bin/nm
RANLIB=/usr/obj/${TARGET_ARCH}.${TARGET_ARCH}/usr/src/tmp/usr/bin/gnu-ranlib
LD=/usr/obj/${TARGET_ARCH}.${TARGET_ARCH}/usr/src/tmp/usr/bin/ld
OBJCOPY=/usr/obj/${TARGET_ARCH}.${TARGET_ARCH}/usr/src/tmp/usr/bin/objcopy
SIZE=/usr/obj/${TARGET_ARCH}.${TARGET_ARCH}/usr/src/tmp/usr/bin/size
AR=/usr/obj/${TARGET_ARCH}.${TARGET_ARCH}/usr/src/tmp/usr/bin/gnu-ar
STRIPBIN=/usr/obj/${TARGET_ARCH}.${TARGET_ARCH}/usr/src/tmp/usr/bin/strip
.endif # TARGET crossbuild.
.endif # include

# In the future may need:
# LDFLAGS+="-rpath=/usr/obj/mips.mipsel/usr/src/tmp/lib:/usr/obj/mips.mipsel/usr/src/tmp/usr/lib -L/usr/obj/mips.mipsel/usr/src/tmp/lib -L/usr/obj/mips.mipsel/usr/src/tmp/usr/lib -L/usr/obj/mips.mipsel/usr/src/lib"

#
# XXXTR: passing TARGET_ARCH kind of "poisons the env" here,
# it's internal but still breaks because /usr/src/Makefile
# doesn't check for it.
#
dotcbuild:
	cd ${SRC_TREE} && make TARGET=${TARGET} TARGET_ARCH=${TARGET_ARCH} toolchain
